> This page is for Itential Platform Cloud.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs-test.itntl.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs-test.itntl.com/_mcp/server.

# Get a page of workflow documents

GET https://example.itential.io/automation-studio/workflows

Returns a page of workflow documents.

Reference: https://docs-test.itntl.com/itential-cloud/api-reference/automation-studio/get-workflows

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Query parameters

- `limit` (integer, optional, default: 25) — Number of results to return. Used for pagination.
- `skip` (integer, optional, default: 0) — Number of results to skip. Used for pagination.
- `order` (enum, optional, default: 1) — Sort direction, 1 for ascending and -1 for descending.
  - Allowed values: `-1`, `1`
- `sort` (enum, optional, default: name) — Field to sort by
  - Allowed values: `name`
- `exclude-project-members` (boolean, optional) — Flag which removes workflows from the results which are members of a project
- `include` (string, optional) — Inclusive projection operator formatted as a comma-delineated list. '_id' will be included implicitly unless excluded with 'exclude=_id'. May only be used in conjunction with 'exclude' when 'exclude=_id'.
- `exclude` (string, optional) — Exclusive projection operator formatted as a comma-delineated list. May only be used in conjunction with 'include' when 'exclude=_id'.
- `expand` (string, optional) — Sets the fields to expand. Generally, these are fields like "metrics.user", "metrics.owner", "created_by", etc
- `in` (string, optional) — Search for fields exactly matching one of the given list options
- `not-in` (string, optional) — Search for fields not exactly matching one of the given list options
- `equals` (string, optional) — Returns results where the specified fields exactly match the given match string(s).
- `contains` (string, optional) — Returns results where the specified fields contain the given match string(s).
- `starts-with` (string, optional) — Returns results where the specified fields start with the given match string(s).
- `ends-with` (string, optional) — Returns results where the specified fields end in the given match string(s).
- `task-equals` (string, optional) — Returns results where one or more tasks have fields that exactly match the given match string(s).

## Response

### 200

Results for the given search parameters.

- `items` (list of automation-studio_workflowDocument, optional)
- `total` (integer, optional) — Total number of documents matching the given query parameters.
- `start` (integer, optional) — Search index of first document in the items array.
- `end` (integer, optional) — Search index of the last document in the items array.
- `count` (integer, optional) — Length of the items array.
- `limit` (integer, optional) — Number of results to return. Used for pagination.
- `next` (string, optional, nullable) — URI pointing to the next set of paginated results. Preserves previous search and projection parameters. Null if returning the last page of results.
- `previous` (string, optional, nullable) — URI pointing to the previous set of paginated results. Preserves previous search and projection parameters. Null if returning the first page of results.

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Types

### automation-studio_workflowDocument

Third generation workflow document as it exists in the database

- `name` (string, required)
- `type` (string, required, default: automation)
- `tasks` (AutomationStudioWorkflowDocumentTasks, required)
- `transitions` (AutomationStudioWorkflowDocumentTransitions, required)
- `groups` (list of string, required)
- `canvasVersion` (double, required)
- `_id` (string, optional)
- `uuid` (string, optional)
- `namespace` (AutomationStudioWorkflowDocumentNamespace, optional)
- `description` (string, optional, nullable)
- `preAutomationTime` (integer, optional) — Time (milliseconds) automation would have taken someone to complete without using IAP.
- `sla` (integer, optional)
- `errorHandler` (AutomationStudioWorkflowDocumentErrorHandler, optional, nullable) — Deprecated gen2-specific feature
- `font_size` (integer, optional, default: 12) — Deprecated, unused, gen1-specific feature
- `created` (string, optional)
- `created_by` (AutomationStudioWorkflowDocumentCreatedBy, optional)
- `createdVersion` (string, optional)
- `last_updated` (string, optional)
- `last_updated_by` (AutomationStudioWorkflowDocumentLastUpdatedBy, optional)
- `lastUpdatedVersion` (string, optional) — This value represents the semantic version of the application that last modified it. For workflows with canvasVersion = 1, this field will refer to the version of Workflow Builder. For workflows with canvasVersion > 1, this field will refer to the version of Studio.
- `tags` (list of string, optional)
- `encodingVersion` (enum, optional)
  - Allowed values: `1`
- `inputSchema` (AutomationStudioWorkflowDocumentInputSchema, optional)
- `outputSchema` (AutomationStudioWorkflowDocumentOutputSchema, optional)
- `outputData` (map from string to AutomationStudioWorkflowDocumentOutputData, optional) — Deprecated gen2-specific feature
- `decorators` (list of AutomationStudioWorkflowDocumentDecoratorsItems, optional)
- `migrationVersion` (integer, optional)
- `scenarios` (list of AutomationStudioWorkflowDocumentScenariosItems, optional)

### AutomationStudioWorkflowDocumentTasks

- `workflow_start` (AutomationStudioWorkflowDocumentTasksWorkflowStart, required)
- `workflow_end` (AutomationStudioWorkflowDocumentTasksWorkflowEnd, required)
- `error_handler` (AutomationStudioWorkflowDocumentTasksErrorHandler, optional) — Deprecated gen2-specific feature

### AutomationStudioWorkflowDocumentTransitions

- `workflow_start` (AutomationStudioWorkflowDocumentTransitionsWorkflowStart, required)
- `workflow_end` (AutomationStudioWorkflowDocumentTransitionsWorkflowEnd, required)
- `error_handler` (AutomationStudioWorkflowDocumentTransitionsErrorHandler, optional)

### AutomationStudioWorkflowDocumentNamespace

- `type` (any, required)
- `_id` (AutomationStudioWorkflowDocumentNamespaceId, required) — A MongoDB ObjectId
- `name` (string, required)

### AutomationStudioWorkflowDocumentErrorHandler

Deprecated gen2-specific feature

- `type` (string, optional)
- `name` (string, optional)

### AutomationStudioWorkflowDocumentCreatedBy

### AutomationStudioWorkflowDocumentLastUpdatedBy

### AutomationStudioWorkflowDocumentInputSchema

### AutomationStudioWorkflowDocumentOutputSchema

### AutomationStudioWorkflowDocumentOutputData

- `taskId` (string, optional)
- `taskPointer` (string, optional)

### AutomationStudioWorkflowDocumentDecoratorsItems

- `type` (enum, optional)
  - Allowed values: `encryption`, `query`
- `pointer` (string, optional)
- `displayPath` (string, optional) — Human-readable dot/bracket notation query (for query decorators)

### AutomationStudioWorkflowDocumentScenariosItems

- `name` (string, required)
- `input` (AutomationStudioWorkflowDocumentScenariosItemsInput, required)
- `description` (string, optional)
- `taskMocks` (AutomationStudioWorkflowDocumentScenariosItemsTaskMocks, optional)
- `last_updated` (string, optional)
- `last_updated_by` (AutomationStudioWorkflowDocumentScenariosItemsLastUpdatedBy, optional)

### AutomationStudioWorkflowDocumentTasksWorkflowStart

- `name` (string, optional)
- `summary` (string, optional)
- `groups` (list of string, optional)
- `nodeLocation` (AutomationStudioWorkflowDocumentTasksWorkflowStartNodeLocation, optional) — Stores the coordinates used by canvasVersion: 3 workflows
- `x` (double, optional)
- `y` (double, optional)

### AutomationStudioWorkflowDocumentTasksWorkflowEnd

- `name` (string, optional)
- `summary` (string, optional)
- `groups` (list of string, optional)
- `nodeLocation` (AutomationStudioWorkflowDocumentTasksWorkflowEndNodeLocation, optional) — Stores the coordinates used by canvasVersion: 3 workflows
- `x` (double, optional)
- `y` (double, optional)

### AutomationStudioWorkflowDocumentTasksErrorHandler

Deprecated gen2-specific feature

- `name` ("childJob", required)
- `summary` (string, required)
- `description` (string, required)
- `app` (string, required)
- `variables` (AutomationStudioWorkflowDocumentTasksErrorHandlerVariables, required)
- `groups` (list of string, required)
- `type` ("operation", required)
- `nodeLocation` (AutomationStudioWorkflowDocumentTasksErrorHandlerNodeLocation, optional) — Stores the coordinates used by canvasVersion: 3 workflows
- `x` (double, optional)
- `y` (double, optional)
- `deprecated` (boolean, optional)
- `scheduled` (boolean, optional)
- `retrySettings` (AutomationStudioWorkflowDocumentTasksErrorHandlerRetrySettings, optional, nullable) — Retry settings for a task.

### AutomationStudioWorkflowDocumentTransitionsWorkflowStart

### AutomationStudioWorkflowDocumentTransitionsWorkflowEnd

### AutomationStudioWorkflowDocumentTransitionsErrorHandler

### AutomationStudioWorkflowDocumentNamespaceId

A MongoDB ObjectId

### AutomationStudioWorkflowDocumentCreatedBy0

- `username` (string, required)
- `provenance` (string, required)

### AutomationStudioWorkflowDocumentLastUpdatedBy0

- `username` (string, required)
- `provenance` (string, required)

### AutomationStudioWorkflowDocumentScenariosItemsInput

### AutomationStudioWorkflowDocumentScenariosItemsTaskMocks

### AutomationStudioWorkflowDocumentScenariosItemsLastUpdatedBy

### AutomationStudioWorkflowDocumentTasksWorkflowStartNodeLocation

Stores the coordinates used by canvasVersion: 3 workflows

- `x` (double, required)
- `y` (double, required)

### AutomationStudioWorkflowDocumentTasksWorkflowEndNodeLocation

Stores the coordinates used by canvasVersion: 3 workflows

- `x` (double, required)
- `y` (double, required)

### AutomationStudioWorkflowDocumentTasksErrorHandlerVariables

- `incoming` (AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesIncoming, required)
- `outgoing` (AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesOutgoing, required)
- `error` (string, optional)
- `decorators` (list of AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesDecoratorsItems, optional)

### AutomationStudioWorkflowDocumentTasksErrorHandlerNodeLocation

Stores the coordinates used by canvasVersion: 3 workflows

- `x` (double, required)
- `y` (double, required)

### AutomationStudioWorkflowDocumentTasksErrorHandlerRetrySettings

Retry settings for a task.

- `state` (list of enum, required) — Finish states the task will retry on. The task will retry on any of the included states.
  - Allowed values: `success`, `error`, `failure`
- `autoRetry` (boolean, required) — Whether the task is set to retry automatically or manually.
- `limit` (integer, required) — Limit of retries on a task before it will take normal transitions and stop retrying.
- `delay` (integer, required) — Delay between each retry in milliseconds.
- `count` (integer, optional) — Current retry count used for workflow engine job processing

### AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesIncoming

### AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesOutgoing

### AutomationStudioWorkflowDocumentTasksErrorHandlerVariablesDecoratorsItems

- `type` (enum, optional)
  - Allowed values: `encryption`, `query`
- `pointer` (string, optional)
- `displayPath` (string, optional) — Human-readable dot/bracket notation query (for query decorators)

## Examples

**Response**

```json
{
  "items": [
    {
      "name": "Port Turn Up IOS",
      "type": "automation",
      "tasks": {
        "workflow_start": {
          "name": "string",
          "summary": "string",
          "groups": [
            "62a1f3d2ebedfc54e6e0065c"
          ],
          "nodeLocation": {
            "x": 1.1,
            "y": 1.1
          },
          "x": 1.1,
          "y": 1.1
        },
        "workflow_end": {
          "name": "string",
          "summary": "string",
          "groups": [
            "62a1f3d2ebedfc54e6e0065c"
          ],
          "nodeLocation": {
            "x": 1.1,
            "y": 1.1
          },
          "x": 1.1,
          "y": 1.1
        },
        "error_handler": {
          "name": "string",
          "summary": "string",
          "description": "string",
          "app": "string",
          "variables": {
            "incoming": {},
            "outgoing": {},
            "error": "string",
            "decorators": [
              {
                "type": "encryption",
                "pointer": "string",
                "displayPath": "string"
              }
            ]
          },
          "groups": [
            "62a1f3d2ebedfc54e6e0065c"
          ],
          "type": "string",
          "nodeLocation": {
            "x": 1.1,
            "y": 1.1
          },
          "x": 1.1,
          "y": 1.1,
          "deprecated": true,
          "scheduled": true,
          "retrySettings": {
            "state": [
              "success"
            ],
            "autoRetry": true,
            "limit": 10,
            "delay": 1000,
            "count": 5
          }
        }
      },
      "transitions": {
        "workflow_start": {},
        "workflow_end": {},
        "error_handler": {}
      },
      "groups": [
        "62a1f3d2ebedfc54e6e0065c"
      ],
      "canvasVersion": 1.1,
      "_id": "string",
      "uuid": "string",
      "namespace": {
        "type": null,
        "_id": {},
        "name": "Juniper JUNOS"
      },
      "description": "Port Turn Up IOS",
      "preAutomationTime": 5000,
      "sla": 1,
      "errorHandler": null,
      "font_size": 12,
      "created": "2024-03-13T18:21:15.352Z",
      "created_by": {
        "provenance": "Pronghorn",
        "username": "admin@pronghorn"
      },
      "createdVersion": "5.40.5-2021.1.72.0",
      "last_updated": "2024-03-13T18:21:15.352Z",
      "last_updated_by": {
        "provenance": "Pronghorn",
        "username": "admin@pronghorn"
      },
      "lastUpdatedVersion": "4.69.69",
      "tags": [
        "string"
      ],
      "encodingVersion": 1,
      "inputSchema": {},
      "outputSchema": {},
      "outputData": {},
      "decorators": [
        {
          "type": "encryption",
          "pointer": "string",
          "displayPath": "string"
        }
      ],
      "migrationVersion": 1,
      "scenarios": [
        {
          "name": "string",
          "input": {},
          "description": "string",
          "taskMocks": {},
          "last_updated": "2024-01-15T09:30:00Z",
          "last_updated_by": {
            "provenance": "Pronghorn",
            "username": "admin@pronghorn"
          }
        }
      ]
    }
  ],
  "total": 1,
  "start": 1,
  "end": 1,
  "count": 1,
  "limit": 1,
  "next": "string",
  "previous": "string"
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/automation-studio/workflows"

querystring = {"contains":"contains[name]=workflow","ends-with":"ends-with[name]=-workflow","equals":"equals[name]=my-workflow","exclude":"_id","expand":"created_by,user,owner","in":"in[name]=my-workflow,or-this-workflow&in[type]=automation","include":"name","limit":"1","not-in":"not-in[name]=my-workflow,not-this-workflow","skip":"1","starts-with":"starts-with[name]=my-","task-equals":"task-equals[app]=WorkFlowEngine"}

response = requests.get(url, params=querystring)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/automation-studio/workflows?contains=contains%5Bname%5D%3Dworkflow&ends-with=ends-with%5Bname%5D%3D-workflow&equals=equals%5Bname%5D%3Dmy-workflow&exclude=_id&expand=created_by%2Cuser%2Cowner&in=in%5Bname%5D%3Dmy-workflow%2Cor-this-workflow%26in%5Btype%5D%3Dautomation&include=name&limit=1&not-in=not-in%5Bname%5D%3Dmy-workflow%2Cnot-this-workflow&skip=1&starts-with=starts-with%5Bname%5D%3Dmy-&task-equals=task-equals%5Bapp%5D%3DWorkFlowEngine")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```